class ParallelsController < ApplicationController
  # GET /parallels
  # GET /parallels.xml
  def index
    @good_parallels     = Parallel.good
    @recent_parallels   = Parallel.recent
    @popular_parallels = Parallel.popular

    respond_to do |format|
      format.html
    end
  end

  def best
    @title="Best"
    @parallels = Parallel.find_all_by_is_good(true, :order=>"updated_at DESC")
    render "list"
  end

  def recent
    @title="Recent"
    @parallels = Parallel.all(:order=>"created_at DESC")
    render "list"
  end

  def popular
    @title="Popular"
    @parallels = Parallel.all(:order=>"views DESC", :limit=>25)
    render "list"
  end

  def about
    respond_to do |format|
      format.html # index.html.erb
    end
  end

  def clean_session
    session[:link1]  =nil
    session[:player1]=nil
    session[:vid1]   =nil
    session[:name1]  =nil
    session[:link2]  =nil
    session[:player2]=nil
    session[:vid2]   =nil
    session[:name2]  =nil
    session[:start1]   =nil
    session[:start2]  =nil
  end

  def show
    clean_session
    @parallel = Parallel.find_by_urlized(params[:parallel])
    @page = @parallel.name

    views_id = cookies[:views] ? cookies[:views].split("-") : []
    unless views_id.index(@parallel.id.to_s)
      # add
      if views_id==[]
        cookies[:views] = @parallel.id
      else
        cookies[:views] = {:value => cookies[:views] << "-#{@parallel.id}", :expires => Time.now + 20.days}
      end
      @parallel.update_attribute("views", @parallel.views+1)
    end

    respond_to do |format|
      format.html # show.html.erb
    end
  end

  def login
    authenticate_or_request_with_http_basic do |id, password|
      id == "admin" && password == "*nina*"
      session[:is_admin]=true
      redirect_to root_path
    end
  end

  # GET /parallels/1/edit
  def edit
    @parallel = Parallel.find(params[:id])
  end

  def video_id(link)
    link.match(/=([\w]+)/)[1]
  end

  def play_url(link)
    "http://www.youtube.com/v/#{video_id(link)}"
  end

  def preview
    if (link1 = params[:link1]) && (link2 = params[:link2])
      if (name1 = Video.get_video_name_by_url(link1)) && (name2 = Video.get_video_name_by_url(link2))
        session[:link1]   = link1
        session[:player1] = play_url(link1)
        session[:vid1]    = video_id(link1)
        session[:name1]   = name1
        session[:link2]   = link2
        session[:player2] = play_url(link2)
        session[:vid2]    = video_id(link2)
        session[:name2]   = name2
        session[:title]   = params[:title] ? params[:title] : "#{session[:name1]} vs #{session[:name2]}"
        start1            = params[:start1] || 0
        session[:start1]  = start1
        start2            = params[:start2] || 0
        session[:start2]  = start2

        if params[:commit]=="Save"
          if Parallel.find_by_name(session[:title])
            flash[:notice] = "This parallel title was already taken. Please, choose another one."
          else
            v1 = Video.find_or_create_by_vid(session[:vid1])
            v2 = Video.find_or_create_by_vid(session[:vid2])
            v1.update_attribute("name", session[:name1])
            v2.update_attribute("name", session[:name2])
            p = Parallel.create(:video1=>v1, :video2=>v2, :start1=>start1, :start2=>start2, :name=>session[:title])
            if p.save
              clean_session
              redirect_to "/#{p.urlized}", :notice => 'Parallel was successfully created.' and return
            end
          end
        end
        render "preview" and return false
      else
        flash[:notice] = "You must provide valid youtube links."
      end
    end
    redirect_to request.referer
  end


  # PUT /parallels/1
  # PUT /parallels/1.xml
  def update
    @parallel = Parallel.find(params[:id])

    respond_to do |format|
      if @parallel.update_attributes(params[:parallel])
        format.html { redirect_to(@parallel, :notice => 'Parallel was successfully updated.') }
        format.xml { head :ok }
      else
        format.html { render :action => "edit" }
        format.xml { render :xml => @parallel.errors, :status => :unprocessable_entity }
      end
    end
  end

  def like
    if session[:is_admin]
      @parallel = Parallel.find(params[:id])
      toogle = @parallel.is_good?
      @parallel.update_attribute("is_good", !toogle)
      redirect_to("/#{@parallel.urlized}", :notice=>"Parallel curated.")
      end
  end

  def destroy
    if session[:is_admin]
      @parallel = Parallel.find(params[:id])
      tags = @parallel.tags
      @parallel.tags = []
      @parallel.save
      tags.each do |t|
        if t.parallels.count == 0
          t.destroy
        end
      end
      @parallel.destroy

      respond_to do |format|
        format.html { redirect_to(root_path, :notice=>"Parallel deleted.") }
        format.xml { head :ok }
      end
    end
  end

end
